# Bash Utils - Documents > References


## Description
Various references used in project.


## General Syntax References
### Shebang Line
<https://linuxize.com/post/bash-shebang/>

### Local Variables
<https://tldp.org/LDP/abs/html/localvar.html>

### For Loops
<https://www.cyberciti.biz/faq/bash-for-loop/>

### Functions
<https://tldp.org/HOWTO/Bash-Prog-Intro-HOWTO-8.html>
<https://www.linuxjournal.com/content/return-values-bash-functions>

### Arrays
* General Arrays - <https://opensource.com/article/18/5/you-dont-know-bash-intro-bash-arrays>
* Get Array Length - <https://unix.stackexchange.com/a/193042>
* Check for Element - <https://stackoverflow.com/a/15394738>

### Dictionaries
<https://stackoverflow.com/questions/1494178/how-to-define-hash-tables-in-bash>


## References

### Directory Handling
#### Including other Script Files
<https://stackoverflow.com/a/10823650>

#### Getting Directory of Calling Script
<https://stackoverflow.com/a/59916>
<https://stackoverflow.com/a/246128>

#### Get Absolute Directory
<https://stackoverflow.com/a/21188136>

### Text Manipulation
#### Change Output Color
<https://stackoverflow.com/a/5947802>

#### String Upper/Lower Case
<https://stackoverflow.com/a/2264537>

#### String Trimming Manipulation
<https://stackoverflow.com/a/14703709>

#### Substring Matching
<https://linuxize.com/post/how-to-check-if-string-contains-substring-in-bash/>

### Other
#### Check Number of Passed Args
<https://stackoverflow.com/a/6482403>

#### Get User's name
<https://stackoverflow.com/a/19306837>

#### Check for Root User
<https://stackoverflow.com/a/18216122>

#### Get User Input
<https://ryanstutorials.net/bash-scripting-tutorial/bash-input.php>
